Subject: wu-ftpd -- VERY odd problem

From: Yoshi <[email-masked]>
Date: Fri, 13 Dec 1996 17:16:56 -0800 (PST)

(I'm sure you've all heard of a similar problem, but maybe not
	 one quite like this...)

# /bin/ftp
ftp> o localhost
Connected to localhost.
220 onyx FTP server (Version wu-2.4.2-academ[BETA-11](1) Fri Dec 13 16:41:51 PST 1996) ready.
Name (localhost:): yoshi
421 Service not available, remote server has closed connection
Login failed.
No control connection for command: No such file or directory
ftp>

	Immediatly at this point, I receive the following error in syslog:

Dec 13 17:13:04 onyx ftpd[4042]: exiting on signal 11

	/etc/ftpaccess is being used (#define USE_ETC), as shown below:

# strings -a /usr/sbin/wu.ftpd | grep ftpaccess
/etc/ftpaccess
Too many args (>%d) in ftpaccess: %s %s %s %s %s ...

	And these are the command-line arguments i'm passing:

# grep ftp /etc/inetd.conf
ftp     stream  tcp     nowait  root    /usr/sbin/tcpd  /usr/sbin/wu.ftpd -a -l

	What i'm concerned about is the "No control connection for command"
	line sent to me via wu-ftpd. As you can see, I am using the -a, -d,
	and -l options. /etc/ftpaccess exists, and is readable.

	If I remove the '-a' option, the aforementioned error goes away,
	and lets my users login: the drawback is that I cannot make use
	of the "/home/username/./" feature for chroot() in limiting users
	to which directory is considered root (/). The user 'yoshi' is
	a normal user, with no "wu-ftp" features in his path or etc..

	If someone could direct me on what exactly is causing this problem,
	i'd be grateful, as our ISP requires the "/./" feature.

	Ah, and before I forget: Linux v2.0.27, libc 5.3.12, gcc 2.7.2.

	Thanks.

--
| Jeremy Chadwick                                        [email-masked] |
| System/Network/Security Administrator                        541-330-0435 |
| http://yoshi.parodius.com                                                 |

---

From: [email-masked] (Keith Iverson)
Date: Fri, 13 Dec 1996 20:16:14 -0800 (PST)

Yes, I had a very similar problem, just after entering a user name I 
would get the same error that you are reporting.  The advice that I got, 
which has made everything work perfectly, is as follows.  Signal 11 is a 
segmentation violation which could indicate that an address is not being 
properly de-referrenced...i.e., a bug in the program.  The solution I 
received was simple, but worked perfectly.  All I did was re-compile the 
ftpd using the latest gcc compiler.  I was using gcc 2.4.5, which is 
ancient and caused the problems.  The newest is gcc 2.7.2.1

-Keith  

> >	(I'm sure you've all 
heard of a similar problem, but maybe not >	 one quite like this...)
>	Ah, and before I forget: Linux v2.0.27, libc 5.3.12, gcc 2.7.2.

<======================================================>
Keith A. Iverson        Iverson Financial Systems, Inc.
New Product Research and Development
E-mail - [email-masked]
Voice - (408)522-9900               Fax - (408)522-9911
<======================================================>

---

From: Yoshi <[email-masked]>
Date: Sun, 15 Dec 1996 00:09:54 -0800 (PST)

> ancient and caused the problems.  The newest is gcc 2.7.2.1

	I receive the exact same premature exit 'signal 11'; I have
	upgraded to gcc v2.7.2.1, and libc 5.4.13, as shown:

# ls -l /lib/libc.so.5*
lrwxrwxrwx   1 root     root           14 Dec 14 23:44 /lib/libc.so.5 -> libc.so
.5.4.17
lrwxrwxrwx   1 root     root           14 Dec 14 23:44 /lib/libc.so.5.3.12 -> li
bc.so.5.4.17
-rwxr-xr-x   1 bin      bin       1816182 Dec  6 17:34 /lib/libc.so.5.4.17
# gcc -v
Reading specs from /usr/lib/gcc-lib/i486-linux/2.7.2.1/specs
gcc version 2.7.2.1

	I also tried removing the -O2 level optimization, dropping it down
	to just -O.

	Any other ideas? I'm desperate to get this working, as a few of
	our customers need this type of feature.